<?php
// $Id: site_network.authentication.inc,v 1.1.2.3 2008/07/31 04:24:12 brmassa Exp $
/**
 * @file
 * All authentication functions.
 */

/**
 * Validate the user based on another Drupal site
 *
 * @ingroup $form
 */
function _site_network_login_validate(&$form, &$form_state) {
  if (variable_get('site_network_client', FALSE)) {
    // The username must be split in two: the first part is the
    // username itself and the second is the server
    $username = explode('@', $form_state['values']['name']);
    $server   = $username[1];
    $username = $username[0];

    // If no server was specified, get the default option if its required
    if (empty($server) and variable_get('site_network_client_server', '')) {
      $server = variable_get('site_network_client_server', '');
    }

    // If a server exists, use it
    if (!empty($server)) {
      $aid = xmlrpc("http://$server/xmlrpc.php", 'drupal.login', $username, $form_state['values']['pass']);

      // Log using the external account if the authentication succeded
      if (!empty($aid)) {
        // Disable the other validation processes, since it already passed
        $form_state['#validate'] = array();
        $form_state['#submit']  = array();

        // Check if the account already exists or its a new user
        $account = user_external_load($aid);
        if (isset($account->uid)) {
          user_external_login($account);
        }
        else {
          user_external_login_register($form_state['values']['name'], 'site_network');
        }
      }
      elseif (variable_get('site_network_client_server_only', FALSE)) {
        // Disable the other validation processes, since it already failed
        $form_state['#validate'] = array();
        $form_state['#submit']  = array();

        form_set_error('name', t("Sorry, unrecognized username or password."));
      }
    }
    elseif (variable_get('site_network_client_server_only', FALSE)) {
      form_set_error('name', t('Server not set'));
    }
  }
}
